/*
 * Copyright (c) 1998-2008 Caucho Technology -- all rights reserved
 *
 * @author Scott Ferguson
 */

package com.caucho.jms.cluster;

import java.io.*;
import java.util.logging.*;

import javax.annotation.*;
import javax.jms.*;

import com.caucho.config.ConfigException;
import com.caucho.jms.message.*;
import com.caucho.jms.queue.*;
import com.caucho.jms.connection.*;
import com.caucho.jms.file.*;
import com.caucho.server.cluster.*;
import com.caucho.util.L10N;
import com.caucho.vfs.*;

/**
 * Implements a cluster receive queue.
 */
public interface ServerDestination
{
  public MessageImpl createMessage(int type);
  
  public void sendCluster(MessageImpl msg, long timeout)
    throws JMSException;
  
  public MessageImpl receiveCluster(String subscription, boolean isAutoAck)
    throws JMSException;
  
  public boolean hasMessage(String subscription);
  
  public void acknowledge(String msgId);
  
  public void rollback(String msgId);
}

