/*
 * Copyright (c) 1998-2008 Caucho Technology -- all rights reserved
 *
 * @author Scott Ferguson
 */

package com.caucho.profile;

import java.util.logging.*;

import com.caucho.config.*;
import com.caucho.util.*;

/**
 * Resin's profiling class.
 */
public class Heap {
  private static final Logger log = Logger.getLogger(Heap.class.getName());
  private static final L10N L = new L10N(Heap.class);

  private static boolean _hasJni;
  private static Heap _heap = new Heap();

  private static Object _lastDump;

  public Heap()
  {
  }

  public Object lastDump()
  {
    return _lastDump;
  }
  
  public Object dump()
  {
    if (! _hasJni)
      return null;
    
    synchronized (Heap.class) {
      _lastDump = nativeHeapDump();

      return _lastDump;
    }
  }
  
  public static native Object nativeHeapDump();

  static {
    try {
      System.loadLibrary("resin");
      _hasJni = true;
    } catch (Throwable e) {
      log.log(Level.FINE, e.toString(), e);
    }
  }
}
