/*
 * Copyright (c) 1998-2008 Caucho Technology -- all rights reserved
 *
 * @author Scott Ferguson
 */

package com.caucho.profile;

import java.util.*;

/**
 * A profile entry
 */
public class ProfileEntry {
  private long _count;
  private long _size;

  private ArrayList<StackEntry> _stack = new ArrayList<StackEntry>();

  public ProfileEntry(long count, long size)
  {
    _count = count;
    _size = size;
  }

  public void addStack(String className,
                       String methodName,
                       String argString)
  {
    _stack.add(new StackEntry(className, methodName, argString));
  }
  
  public long getCount()
  {
    return _count;
  }

  public ArrayList<StackEntry> getStackTrace()
  {
    return _stack;
  }

  public String getDescription()
  {
    for (int i = 0; i < _stack.size(); i++) {
      StackEntry entry = _stack.get(i);

      if (! "".equals(entry.getArg())
          && "com.caucho.sql.UserStatement".equals(entry.getClassName())
          && "execute".equals(entry.getMethodName())) {
        return "SQL-query: '"  + entry.getArg() + "'";
      }
    }
    
    if (_stack.size() > 0)
      return _stack.get(0).getDescription();
    else
      return "unknown";
  }

  public String toString()
  {
    return "ProfileEntry[" + _count + "," + _size + "]" + _stack;
  }
}
