/*
 * Copyright (c) 1998-2008 Caucho Technology -- all rights reserved
 *
 * @author Scott Ferguson
 */

package com.caucho.quercus.expr;

import com.caucho.quercus.gen.AnalyzeInfo;
import com.caucho.quercus.gen.PhpWriter;

import java.io.IOException;

/**
 * Represents a PHP default expression.
 */
public class ProDefaultExpr extends DefaultExpr
  implements CompilingExpr
{
  public ProDefaultExpr()
  {
    super();
  }

  public GenerateExpr getGenerator()
  {
    return GENERATOR;
  }

  public final GenerateExpr GENERATOR = new GenerateExpr(getLocation()) {
      public void analyze(AnalyzeInfo info)
      {
      }
      
      /**
       * Generates code to recreate the expression.
       *
       * @param out the writer to the Java source code.
       */
      public void generate(PhpWriter out)
	throws IOException
      {
	out.print("DefaultValue.DEFAULT");
      }

      /**
       * Generates code to recreate the expression.
       *
       * @param out the writer to the Java source code.
       */
      public void generateLong(PhpWriter out)
	throws IOException
      {
	out.print("0");
      }

      /**
       * Generates code to recreate the expression.
       *
       * @param out the writer to the Java source code.
       */
      public void generateString(PhpWriter out)
	throws IOException
      {
	out.print("\"\"");
      }
    };
}

