/*
 * Copyright (c) 1998-2008 Caucho Technology -- all rights reserved
 *
 * @author Scott Ferguson
 */

package com.caucho.quercus.expr;

import com.caucho.quercus.gen.AnalyzeInfo;
import com.caucho.quercus.gen.PhpWriter;

import java.io.IOException;

/**
 * Represents the die expression
 */
public class ProDieExpr extends DieExpr
  implements CompilingExpr
{
  public ProDieExpr(Expr value)
  {
    super(value);
  }

  public ProDieExpr()
  {
    _value = null;
  }

  public GenerateExpr getGenerator()
  {
    return GENERATOR;
  }

  private GenerateExpr GENERATOR = new GenerateExpr(getLocation()) {
      /**
       * Analyze the expression
       */
      public void analyze(AnalyzeInfo info)
      {
	CompilingExpr value = (CompilingExpr) _value;
	
	if (value != null)
	  value.getGenerator().analyze(info);
      }

      /**
       * Generates code to evaluate the expression
       *
       * @param out the writer to the Java source code.
       */
      public void generate(PhpWriter out)
	throws IOException
      {
	CompilingExpr value = (CompilingExpr) _value;
	
	if (value != null) {
	  out.print("env.die(");
	  value.getGenerator().generateString(out);
	  out.print(")");
	}
	else {
	  out.print("env.die()");
	}
      }
    };
}

