/*
 * Copyright (c) 1998-2008 Caucho Technology -- all rights reserved
 *
 * @author Scott Ferguson
 */

package com.caucho.quercus.expr;

import com.caucho.quercus.Location;
import com.caucho.quercus.gen.AnalyzeInfo;
import com.caucho.quercus.gen.PhpWriter;

import java.io.IOException;

/**
 * Represents a PHP comparison expression.
 */
public class ProImportExpr extends ImportExpr
  implements CompilingExpr
{
  public ProImportExpr(Location location, String name, boolean isWildcard)
  {
    super(location, name, isWildcard);
  }

  public GenerateExpr getGenerator()
  {
    return GENERATOR;
  }

  private GenerateExpr GENERATOR = new GenerateExpr(getLocation()) {

      //
      // Generates the java code
      //

      /**
       * Analyze the expression
       */
      public void analyze(AnalyzeInfo info)
      {
      }
      
      /**
       * Generates code to evaluate the expression
       *
       * @param out the writer to the Java source code.
       */
      public void generate(PhpWriter out)
        throws IOException
      {
        if (_isWildcard) {
          out.print("env.addWildcardImport(\"");
        }
        else {
          out.print("env.putQualifiedImport(\"");
        }
        
        out.printJavaString(_name);
        out.print("\")");
      }
    };
}

