/*
 * Copyright (c) 1998-2008 Caucho Technology -- all rights reserved
 *
 * @author Scott Ferguson
 */

package com.caucho.quercus.expr;

import com.caucho.quercus.env.Env;
import com.caucho.quercus.env.Value;
import com.caucho.quercus.gen.AnalyzeInfo;
import com.caucho.quercus.gen.PhpWriter;

import java.io.IOException;

/**
 * Represents an expression generated by the create routines.
 */
public class ProRawExpr extends Expr
  implements CompilingExpr
{
  private String _code;

  public ProRawExpr(String code)
  {
    _code = code;
  }

  public Value eval(Env env)
  {
    throw new UnsupportedOperationException();
  }

  public GenerateExpr getGenerator()
  {
    return GENERATOR;
  }

  private GenerateExpr GENERATOR = new GenerateExpr(getLocation()) {
      public void analyze(AnalyzeInfo info)
      {
      }
      
      public void generate(PhpWriter out)
	throws IOException
      {
	out.print(_code);
      }
    };
}

