/*
 * Copyright (c) 1998-2008 Caucho Technology -- all rights reserved
 *
 * @author Scott Ferguson
 */

package com.caucho.quercus.expr;

import com.caucho.quercus.gen.PhpWriter;
import com.caucho.quercus.gen.AnalyzeInfo;
import com.caucho.quercus.Location;

import java.io.IOException;

/**
 * Represents a PHP required expression.
 */
public class ProRequiredExpr extends RequiredExpr
  implements CompilingExpr
{
  public static final ProRequiredExpr REQUIRED = new ProRequiredExpr();

  public ProRequiredExpr()
  {
    super();
  }

  public GenerateExpr getGenerator()
  {
    return GENERATOR;
  }

  public final GenerateExpr GENERATOR = new GenerateExpr(getLocation()) {
      public void analyze(AnalyzeInfo info)
      {
      }
      
      public void generate(PhpWriter out)
	throws IOException
      {
	out.print("RequiredExpr.REQUIRED.eval(env)");
      }
      
      /**
       * Generates code to recreate the expression.
       *
       * @param out the writer to the Java source code.
       */
      public void generateExpr(PhpWriter out)
	throws IOException
      {
	out.print("RequiredExpr.REQUIRED");
      }
    };
}

