/*
 * Copyright (c) 1998-2008 Caucho Technology -- all rights reserved
 *
 * @author Scott Ferguson
 */

package com.caucho.quercus.expr;

import com.caucho.quercus.env.Env;
import com.caucho.quercus.env.Value;
import com.caucho.quercus.gen.AnalyzeInfo;
import com.caucho.quercus.gen.PhpWriter;

import java.io.IOException;

/**
 * Dummy for code generation
 */
public class ProSetCharAtExpr extends Expr
  implements CompilingExpr
{
  private Expr _objExpr;
  private Expr _indexExpr;
  private Expr _valueExpr;
  
  public ProSetCharAtExpr(Expr objExpr, Expr indexExpr, Expr valueExpr)
  {

    _objExpr = objExpr;
    _indexExpr = indexExpr;
    _valueExpr = valueExpr;
  }
  
  /**
   * Evaluates the expression.
   *
   * @param env the calling environment.
   *
   * @return the expression value.
   */
  public Value eval(Env env)
  {
    throw new UnsupportedOperationException();
  }

  public GenerateExpr getGenerator()
  {
    return GENERATOR;
  }

  private GenerateExpr GENERATOR = new GenerateExpr(getLocation()) {
      public void analyze(AnalyzeInfo info)
      {
      }
      
      /**
       * Generates code to evaluate the expression.
       *
       * @param out the writer to the Java source code.
       */
      public void generate(PhpWriter out)
	throws IOException
      {
	GenerateExpr objGen = ((CompilingExpr) _objExpr).getGenerator();
	GenerateExpr indexGen = ((CompilingExpr) _indexExpr).getGenerator();
	GenerateExpr valueGen = ((CompilingExpr) _valueExpr).getGenerator();
	
	objGen.generate(out);
	out.print(".setCharValueAt(");
	indexGen.generateLong(out);
	out.print(",");
	valueGen.generateString(out);
	out.print(")");
      }
    };
}

