/*
 * Copyright (c) 1998-2008 Caucho Technology -- all rights reserved
 *
 * @author Scott Ferguson
 */

package com.caucho.quercus.expr;

import com.caucho.quercus.gen.AnalyzeInfo;
import com.caucho.quercus.gen.PhpWriter;

import java.io.IOException;

/**
 * Represents unsetting a PHP variable
 */
public class ProUnsetVarExpr extends UnsetVarExpr
  implements CompilingExpr
{
  public ProUnsetVarExpr(AbstractVarExpr var)
  {
    super(var);
  }

  public GenerateExpr getGenerator()
  {
    return GENERATOR;
  }

  private GenerateExpr GENERATOR = new GenerateExpr(getLocation()) {
      /**
       * Analyze the expression
       */
      public void analyze(AnalyzeInfo info)
      {
	GenerateExpr varGen = ((CompilingExpr) _var).getGenerator();
	
	varGen.analyzeUnset(info);
      }

      /**
       * Generates code to evaluate the expression
       *
       * @param out the writer to the Java source code.
       */
      public void generate(PhpWriter out)
	throws IOException
      {
        GenerateExpr varGen = ((CompilingExpr) _var).getGenerator();

        varGen.generateUnset(out);
      }
    };
}

