/*
 * Copyright (c) 1998-2008 Caucho Technology -- all rights reserved
 *
 * @author Scott Ferguson
 */

package com.caucho.quercus.expr;

import com.caucho.quercus.Location;
import com.caucho.quercus.gen.AnalyzeInfo;

/**
 * Represents a PHP boolean negation
 */
abstract public class UnaryGenerateExpr extends GenerateExpr {
  public UnaryGenerateExpr(Location location)
  {
    super(location);
  }
  
  /**
   * Returns the child expression.
   */
  abstract protected GenerateExpr getExpr();

  //
  // Java code generation
  //

  /**
   * Analyze the expression
   */
  public void analyze(AnalyzeInfo info)
  {
    getExpr().analyze(info);
  }

  /**
   * Returns the variables state.
   *
   * @param var the variables to test
   * @param owner the owning expression
   */
  public VarState getVarState(ProVarExpr var, ProVarExpr owner)
  {
    throw new UnsupportedOperationException();
    //return getExpr().getVarState(var, owner);
  }

  /**
   * Returns true if the variable is ever assigned.
   *
   * @param var the variable to test
   */
  public boolean isVarAssigned(VarExpr var)
  {
    return getExpr().isVarAssigned(var);
  }
}

