/*
 * Copyright (c) 1998-2008 Caucho Technology -- all rights reserved
 *
 * @author Scott Ferguson
 */

package com.caucho.quercus.function;

import com.caucho.quercus.expr.GenerateExpr;
import com.caucho.quercus.gen.PhpWriter;

import java.io.IOException;

public class ProBooleanObjectMarshal extends BooleanObjectMarshal
  implements ProMarshal
{
  public static final Marshal MARSHAL = new ProBooleanObjectMarshal();

  public void generate(PhpWriter out, GenerateExpr expr, Class argClass)
    throws IOException
  {
    expr.generate(out);
    out.print(".toJavaBoolean()");
  }

  public void generateResultStart(PhpWriter out)
    throws IOException
  {
    out.print("BooleanValue.create(");
  }

  public void generateResultEnd(PhpWriter out)
    throws IOException
  {
    out.print(")");
  }
}
