/*
 * Copyright (c) 1998-2008 Caucho Technology -- all rights reserved
 *
 * @author Scott Ferguson
 */

package com.caucho.quercus.function;

import com.caucho.quercus.expr.GenerateExpr;
import com.caucho.quercus.gen.PhpWriter;

import java.io.IOException;

public class ProExtValueMarshal extends ExtValueMarshal
  implements ProMarshal
{
  public ProExtValueMarshal(Class expectedClass)
  {
    super(expectedClass);
  }
  
  public void generate(PhpWriter out, GenerateExpr expr, Class expectedClass)
    throws IOException
  {
    String className = expectedClass.getName();

    out.print("((");
    out.printClass(expectedClass);
    out.print(") env.cast(");
    out.printClass(expectedClass);
    out.print(".class, ");

    expr.generateValue(out);
    out.print("))");
  }

  public void generateResultStart(PhpWriter out)
    throws IOException
  {
    out.print("((Value) ");
  }

  public void generateResultEnd(PhpWriter out)
    throws IOException
  {
    out.print(")");
  }
}
