/*
 * Copyright (c) 1998-2008 Caucho Technology -- all rights reserved
 *
 * @author Scott Ferguson
 */

package com.caucho.quercus.function;

import com.caucho.quercus.expr.GenerateExpr;
import com.caucho.quercus.gen.PhpWriter;

import java.io.IOException;

public class ProFloatMarshal extends FloatMarshal
  implements ProMarshal
{
  public static final Marshal MARSHAL = new ProFloatMarshal();

  public void generate(PhpWriter out, GenerateExpr expr, Class argClass)
    throws IOException
  {
    out.print("(float) ");
    expr.generateDouble(out);
  }
  
  public void generateResultStart(PhpWriter out)
    throws IOException
  {
    out.print("DoubleValue.create(");
  }

  public void generateResultEnd(PhpWriter out)
    throws IOException
  {
    out.print(")");
  }
}
