/*
 * Copyright (c) 1998-2008 Caucho Technology -- all rights reserved
 *
 * @author Scott Ferguson
 */

package com.caucho.quercus.function;

import com.caucho.quercus.expr.GenerateExpr;
import com.caucho.quercus.gen.PhpWriter;

import java.io.IOException;

public class ProJavaCharacterArrayMarshal extends JavaCharacterArrayMarshal
  implements ProMarshal
{
  public static final Marshal MARSHAL = new ProJavaCharacterArrayMarshal();

  public void generate(PhpWriter out, GenerateExpr expr, Class argClass)
    throws IOException
  {
    String componentTypeName = argClass.getComponentType().getName();

    // cast object to desired array type
    out.print('(');
    out.print(componentTypeName);
    out.print("[])");
    
    expr.generate(out);

    //if (_isNotNull)
      //out.print(".valuesToArrayNotNull(env, ");
    //else
      out.print(".valuesToArray(env, ");

    out.print(componentTypeName);
    out.print(".class)");
  }

  public void generateResultStart(PhpWriter out)
    throws IOException
  {
    out.print("new UnicodeBuilderValue((char[]) ");
  }

  public void generateResultEnd(PhpWriter out)
    throws IOException
  {
    out.print(")");
  }
}
