/*
 * Copyright (c) 1998-2008 Caucho Technology -- all rights reserved
 *
 * @author Scott Ferguson
 */

package com.caucho.quercus.function;

import com.caucho.quercus.expr.GenerateExpr;
import com.caucho.quercus.gen.PhpWriter;
import com.caucho.quercus.program.JavaClassDef;
import com.caucho.util.L10N;

import java.io.IOException;

/**
 * Code for marshaling arguments.
 */
public class ProJavaListMarshal extends JavaListMarshal
  implements ProMarshal
{
  private static final L10N L = new L10N(JavaMarshal.class);

  public ProJavaListMarshal(JavaClassDef def,
                      boolean isNotNull,
                      boolean isUnmarshalNullAsFalse)
  {
    super(def, isNotNull, isUnmarshalNullAsFalse);
  }

  public void generate(PhpWriter out, GenerateExpr expr, Class argClass)
    throws IOException
  {
    out.print("(" + argClass.getName() + ") ");
    expr.generate(out);
    out.print(".toJavaList(env, " + argClass.getName() + ".class)");
  }

  public void generateResultStart(PhpWriter out)
    throws IOException
  {
    out.print("env.wrapJava(");
  }

  public void generateResultEnd(PhpWriter out)
    throws IOException
  {
    if (_isUnmarshalNullAsFalse)
      out.print(", true");

    out.print(")");
  }
}

