/*
 * Copyright (c) 1998-2008 Caucho Technology -- all rights reserved
 *
 * @author Scott Ferguson
 */

package com.caucho.quercus.function;

import com.caucho.quercus.expr.GenerateExpr;
import com.caucho.quercus.gen.PhpWriter;

import java.io.IOException;

public class ProStringMarshal extends StringMarshal
  implements ProMarshal
{
  public static final Marshal MARSHAL = new ProStringMarshal();
  
  public void generate(PhpWriter out, GenerateExpr expr, Class argClass)
    throws IOException
  {
    expr.generate(out);
    out.print(".toJavaString()");
  }

  public void generateResultStart(PhpWriter out)
    throws IOException
  {
    if (out.getPhp().isUnicodeSemantics())
      out.print("UnicodeBuilderValue.create( ");
    else
      out.print("StringBuilderValue.create( ");
  }

  public void generateResultEnd(PhpWriter out)
    throws IOException
  {
    out.print(")");
  }
}
