/*
 * Copyright (c) 1998-2008 Caucho Technology -- all rights reserved
 *
 * @author Scott Ferguson
 */

package com.caucho.quercus.function;

import com.caucho.quercus.expr.GenerateExpr;
import com.caucho.quercus.gen.PhpWriter;

import java.io.IOException;

public class ProURLMarshal extends URLMarshal
  implements ProMarshal
{
  public static final Marshal MARSHAL = new ProURLMarshal();

  public void generate(PhpWriter out, GenerateExpr expr, Class argClass)
    throws IOException
  {
    expr.generateValue(out);

    out.print(".toJavaURL(env)");
  }

  public void generateResultStart(PhpWriter out)
    throws IOException
  {
    out.print("env.wrapJava(");
  }

  public void generateResultEnd(PhpWriter out)
    throws IOException
  {
    out.print(")");
  }
}
