/*
 * Copyright (c) 1998-2008 Caucho Technology -- all rights reserved
 *
 * @author Scott Ferguson
 */

package com.caucho.quercus.module;

import com.caucho.quercus.program.ProStaticFunction;

import java.lang.reflect.Method;

import com.caucho.quercus.function.*;
import com.caucho.quercus.expr.*;

/**
 * Class-loader specific context for loaded PHP.
 */
public class ProModuleContext extends ResinModuleContext {
  private ExprFactory _exprFactory;
  private MarshalFactory _marshalFactory;
  
  /**
   * Constructor.
   */
  public ProModuleContext()
  {
    _marshalFactory = new ProMarshalFactory(this);
    _exprFactory = new ProExprFactory();
  }

  /**
   * Constructor.
   */
  public ProModuleContext(ClassLoader loader)
  {
    super(loader);
    
    _marshalFactory = new ProMarshalFactory(this);
    _exprFactory = new ProExprFactory();
  }

  /**
   * Creates a static function.
   */
  public StaticFunction createStaticFunction(QuercusModule module,
					     Method method)
  {
    return new ProStaticFunction(this, module, method);
  }

  @Override
  public MarshalFactory getMarshalFactory()
  {
    return _marshalFactory;
  }

  @Override
  public ExprFactory getExprFactory()
  {
    return _exprFactory;
  }
}

