/*
 * Copyright (c) 1998-2008 Caucho Technology -- all rights reserved
 *
 * @author Scott Ferguson
 */

package com.caucho.quercus.statement;

import com.caucho.quercus.Location;
import com.caucho.quercus.gen.AnalyzeInfo;
import com.caucho.quercus.gen.PhpWriter;
import com.caucho.quercus.program.ClassDefStatement;
import com.caucho.quercus.program.InterpretedClassDef;

import java.io.IOException;

/**
 * Represents a class definition
 */
public class ProClassDefStatement extends ClassDefStatement
  implements CompilingStatement
{
  public ProClassDefStatement(Location location, InterpretedClassDef cl)
  {
    super(location, cl);
  }

  public StatementGenerator getGenerator()
  {
    return GENERATOR;
  }

  private StatementGenerator GENERATOR = new StatementGenerator() {
      protected Location getLocation()
      {
	return ProClassDefStatement.this.getLocation();
      }
      
      /**
       * Analyze the statement
       */
      public boolean analyze(AnalyzeInfo info)
      {
	return true;
      }

      /**
       * Generates the Java code for the statement.
       *
       * @param out the writer to the generated Java source.
       */
      protected void generateImpl(PhpWriter out)
	throws IOException
      {
        /**
        out.print("if (env.findClass(\"");
	out.printJavaString(_cl.getName());
	out.println("\") == null)");
	out.print("  env.addClass(\"");
	out.printJavaString(_cl.getName());
	out.print("\", new QuercusClass(env.findClassDef(\"");
	out.printJavaString(_cl.getName());
	out.print("\", ");

	if (_cl.getParentName() != null) {
	  out.print("env.getClass(\"");
	  out.printJavaString(_cl.getParentName());
	  out.print("\")");
	}
	else
	  out.print("null");
    
	out.println(")));");
	// XXX:
         */
      }
    };
}

