/*
 * Copyright (c) 1998-2008 Caucho Technology -- all rights reserved
 *
 * @author Sam
 */

package com.caucho.server.admin;

import com.caucho.util.L10N;
import com.caucho.hessian.io.ExtSerializerFactory;

import javax.enterprise.deploy.spi.Target;
import javax.enterprise.deploy.spi.TargetModuleID;
import java.io.InputStream;
import java.io.IOException;

public class DeployClient
  extends HmuxClient
  implements DeployServiceAPI
{
  private static final L10N L = new L10N(DeployClient.class);

  public DeployClient(String serverId)
  {
    super(SERVICE_NAME, serverId);
  }

  public DeployClient(String address, int port)
  {
    super(SERVICE_NAME, address, port);
  }

  protected void initExtSerializerFactory(ExtSerializerFactory factory)
  {
  }

  public Target[] getTargets()
    throws IOException
  {
    ServiceCall call = createServiceCall("getTargets");

    try {
      return call.complete(Target[].class);
    }
    finally {
      call.close();
    }
  }

  public TargetModuleID[] getAvailableModules(String moduleType)
    throws IOException
  {
    ServiceCall call = createServiceCall("getAvailableModules");

    try {
      call.writeString(moduleType);
      return call.complete(TargetModuleID[].class);
    }
    finally {
      call.close();
    }
  }

  public void distribute(Target[] targets,
                         InputStream deploymentPlan,
                         InputStream archiveIs)
  {
    if (true) throw new UnsupportedOperationException("unimplemented");
  }

  public void start(TargetModuleID[] ids)
  {
    if (true) throw new UnsupportedOperationException("unimplemented");
  }

  public void stop(TargetModuleID[] ids)
  {
    if (true) throw new UnsupportedOperationException("unimplemented");
  }

  public void undeploy(TargetModuleID[] ids)
  {
    if (true) throw new UnsupportedOperationException("unimplemented");
  }
}
