/*
 * Copyright (c) 1998-2008 Caucho Technology -- all rights reserved
 *
 * @author Scott Ferguson
 */

package com.caucho.servlets;

import com.caucho.server.cluster.ClusterStream;
import com.caucho.server.cluster.ServerConnector;

/**
 * Strategy for selecting the next server
 */
public class RoundRobinBalanceStrategy extends LoadBalanceStrategy {
  /**
   * Opens the best load balance server.
   */
  @Override
  protected ClusterStream openBestServer(int startIndex,
					 ServerConnector oldSrun)
  {
    int length = _serverGroup.length;
    
    ServerConnector server = _serverGroup[startIndex];

    if (server == null)
      return null;
    else if (server.isDead())
      return null;

    return server.openSoft();
  }
}
